/*********************************************************************/
/* tclparse V2.00 from 14.March 1997                                 */
/* Copyright 1996/97 Stephan Weiss, Heiko Grossmann                  */
/*                   University of Stuttgart, Germany                */
/* For details see the copyright file included in the distribution.  */
/* This notice must not be removed from the file.                    */
/*                                                                   */
/*********************************************************************/

#ifndef _PARSING_H_
#define _PARSING_H_

#include "const.h"
#include "handler.h"


void AddCommand( CCommand &command );
void AddCommand( char *name, char *commandID, char *list, int min=0, int max=0, int calls=0 );
void AddImage( char*, char*, int calls=0 );
int AddVariable( CVariable &variable );
int AddVariable( char*, char*, int status=0, int calls=0 );
void AddWidget( char*, char*, int calls=0 );

char *Buffer( void );
void CopyToBuffer( char *string );

char *Actual( dataType );
char *ActualID( dataType );
char *Last( dataType );
char *LastID( dataType );
char *Next( dataType );
char *NextID( dataType );

void GetAtom( void );
CCommand *GetCommand( char *name );
void GetSymbol( void );
CVariable *GetVariable( char *name, char *environment );
void GetWord( void );
void GetUnit( void );

void HandleError( void );
int LoadInfo( char *fileName );
int LoadVars( char *fileName );
CCommand *ParseArgumentList( void );
char *ParseBraceGroup( void );
char *ParseBracketGroup( void );
int ParseCgetOption( char *commandID );
int ParseCommandEnd( void );
void ParseComment( void );
int ParseConfigureOptions( char *commandID );
char *ParseDollar( void );
void ParseFile( char* );
void ParseGeneric( int, int );
int ParseOptionalUnit( void );
int ParseOptionalWord( void );
int ParseOptions( char *commandID );
char *ParseParenGroup( void );
void ParseProcedure( char* );
char *ParseQuoteGroup( void );
int ParseScript( void );
void ParseTclCommand( char* );
void ParseTkCommand( char* );
void ParseTkWidget( char* );
void ParseTkWidgetCmd( char *command );
int ParseUnit( void );
int ParseUnit( char* );
void ParseUnknownCommand( char* );
int ParseWidget( void );
int ParseWord( void );
int RemoveCommand( char *name );
int RemoveImage( char *name );
int RemoveProcedure( char *name );
int RemoveVariable( CVariable &variable );
int RemoveVariable( char *name, char *environment );
int RemoveWidget( char *name );
void SaveInfo( char* );
int ScanFile( char* );

char *Environment( void );
char *LongToChar( long number );
char *ParentWidget( char* );
char *NextEnvironment( char* );
int IsArray( char *name );
int IsArray( char *name, char *environment );
int IsCommand( char *name );
int IsDigit( char );
int IsElementOf( char *element, char *set );
int IsGlobal( char* );
int IsGroupActive( char* );
int IsGroupEnd( void );
int IsGroupStart( void );
int IsHexDigit( char ch );
int IsImage( char *name );
int IsLastArg( void );
int IsLevel( char *string );
int IsLoopActive( void );
int IsNumber( char *ch );
int IsOctalDigit( char ch );
int IsOption( char *option, char *command );
int IsProcedure( char* );
int IsTclCommand( char* );
int IsTkCommand( char* );
int IsVariable( char *name );
int IsVariable( char *name, char *environment );
int IsWidget( char *name );
int IsWordEnd( void );


#endif
